<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>setState</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      Unlike the lifecycle methods above (which React calls for you), the
      methods below are the methods <em>you</em> can call from your components.
    </p>
    <p>
      There are just two of them: <code>setState()</code> and
      <code>forceUpdate()</code>.
    </p>
    <h3 id="setstate">
      <a href="https://reactjs.org/docs/react-component.html#setstate"></a
      ><code>setState()</code>
    </h3>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="at">setState</span>(updater<span class="op">,</span> [callback])<span class="op">;</span></a></code></pre>
    </div>
    <p>
      <code>setState()</code> enqueues changes to the component state and tells
      React that this component and its children need to be re-rendered with the
      updated state. This is the primary method you use to update the user
      interface in response to event handlers and server responses.
    </p>
    <p>
      Think of <code>setState()</code> as a <em>request</em> rather than an
      immediate command to update the component. For better perceived
      performance, React may delay it, and then update several components in a
      single pass. React does not guarantee that the state changes are applied
      immediately.
    </p>
    <p>
      <code>setState()</code> does not always immediately update the component.
      It may batch or defer the update until later. This makes reading
      <code>this.state</code> right after calling <code>setState()</code> a
      potential pitfall. Instead, use <code>componentDidUpdate</code> or a
      <code>setState</code> callback (<code>setState(updater, callback)</code>),
      either of which are guaranteed to fire after the update has been applied.
      If you need to set the state based on the previous state, read about the
      <code>updater</code> argument below.
    </p>
    <p>
      <code>setState()</code> will always lead to a re-render unless
      <code>shouldComponentUpdate()</code> returns <code>false</code>. If
      mutable objects are being used and conditional rendering logic cannot be
      implemented in <code>shouldComponentUpdate()</code>, calling
      <code>setState()</code> only when the new state differs from the previous
      state will avoid unnecessary re-renders.
    </p>
    <p>
      The first argument is an <code>updater</code> function with the signature:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1">(state<span class="op">,</span> props) <span class="kw">=&gt;</span> stateChange<span class="op">;</span></a></code></pre>
    </div>
    <p>
      <code>state</code> is a reference to the component state at the time the
      change is being applied. It should not be directly mutated. Instead,
      changes should be represented by building a new object based on the input
      from <code>state</code> and <code>props</code>. For instance, suppose we
      wanted to increment a value in state by <code>props.step</code>:
    </p>
    <pre><code>this.setState((state, props) =&gt; {
  return {counter: state.counter + props.step};
});</code></pre>
    <p>
      Both <code>state</code> and <code>props</code> received by the updater
      function are guaranteed to be up-to-date. The output of the updater is
      shallowly merged with <code>state</code>.
    </p>
    <p>
      The second parameter to <code>setState()</code> is an optional callback
      function that will be executed once <code>setState</code> is completed and
      the component is re-rendered. Generally we recommend using
      <code>componentDidUpdate()</code> for such logic instead.
    </p>
    <p>
      You may optionally pass an object as the first argument to
      <code>setState()</code> instead of a function:
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="at">setState</span>(stateChange[<span class="op">,</span> callback])</a></code></pre>
    </div>
    <p>
      This performs a shallow merge of <code>stateChange</code> into the new
      state, e.g., to adjust a shopping cart item quantity:
    </p>
    <pre><code>this.setState({quantity: 2})</code></pre>
    <p>
      This form of <code>setState()</code> is also asynchronous, and multiple
      calls during the same cycle may be batched together. For example, if you
      attempt to increment an item quantity more than once in the same cycle,
      that will result in the equivalent of:
    </p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="va">Object</span>.<span class="at">assign</span>(</a>
<a class="sourceLine" id="cb6-2" title="2">  previousState<span class="op">,</span></a>
<a class="sourceLine" id="cb6-3" title="3">  <span class="op">{</span><span class="dt">quantity</span><span class="op">:</span> <span class="va">state</span>.<span class="at">quantity</span> <span class="op">+</span> <span class="dv">1</span><span class="op">},</span></a>
<a class="sourceLine" id="cb6-4" title="4">  <span class="op">{</span><span class="dt">quantity</span><span class="op">:</span> <span class="va">state</span>.<span class="at">quantity</span> <span class="op">+</span> <span class="dv">1</span><span class="op">},</span></a>
<a class="sourceLine" id="cb6-5" title="5">  ...</a>
<a class="sourceLine" id="cb6-6" title="6">)</a></code></pre>
    </div>
    <p>
      Subsequent calls will override values from previous calls in the same
      cycle, so the quantity will only be incremented once. If the next state
      depends on the current state, we recommend using the updater function
      form, instead:
    </p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">this</span>.<span class="at">setState</span>((state) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="cf">return</span> <span class="op">{</span> <span class="dt">quantity</span><span class="op">:</span> <span class="va">state</span>.<span class="at">quantity</span> <span class="op">+</span> <span class="dv">1</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb7-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
  </body>
</html>
